package com.zcloud.service.system.impl;

import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.mapper.datasource.system.UserInfoMapper;
import com.zcloud.service.system.UserInfoService;
import com.zcloud.util.Smb;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 说明：用户表明细
 * 作者：luoxiaobao
 * 时间：2021-12-07
 * 官网：www.zcloudchina.com
 */
@Service
@Transactional //开启事物
public class UserInfoServiceImpl implements UserInfoService {

	@Autowired
	private UserInfoMapper userinfoMapper;
	@Autowired
	private Smb smb;
	/**新增
	 * @param pd
	 * @throws Exception
	 */
	public void save(PageData pd)throws Exception{
		userinfoMapper.save(pd);
	}

	/**删除
	 * @param pd
	 * @throws Exception
	 */
	public void delete(PageData pd)throws Exception{
		userinfoMapper.delete(pd);
	}

	/**修改
	 * @param pd
	 * @throws Exception
	 */
	public void edit(PageData pd)throws Exception{
		userinfoMapper.edit(pd);
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	public List<PageData> list(Page page)throws Exception{
		return userinfoMapper.datalistPage(page);
	}

	/**列表(全部)
	 * @param pd
	 * @throws Exception
	 */
	public List<PageData> listAll(PageData pd)throws Exception{
		return userinfoMapper.listAll(pd);
	}

	/**通过id获取数据
	 * @param pd
	 * @throws Exception
	 */
	public PageData findById(PageData pd)throws Exception{
		return userinfoMapper.findById(pd);
	}

	/**批量删除
	 * @param ArrayDATA_IDS
	 * @throws Exception
	 */
	public void deleteAll(String[] ArrayDATA_IDS)throws Exception{
		userinfoMapper.deleteAll(ArrayDATA_IDS);
	}

	/**
	 * 清除人员字典信息（职务、职称、工种）
	 * @param pd
	 * @throws Exception
	 */
	@Override
	public void clearDict(PageData pd) throws Exception {
		userinfoMapper.clearDict(pd);
	}
	/**修改 用户签字信息
	 * @param pd
	 * @throws Exception
	 */
	public void editUserSign(PageData pd)throws Exception{
		PageData userInfo = userinfoMapper.findById(pd); // 获取用户详情信息
		if(null == userInfo){
			userinfoMapper.save(pd); // 保存信息
		}else {
			String filePath = userInfo.getString("USER_SIGN_FILE_PATH");
			smb.deleteFile(filePath); //删除附件
			userinfoMapper.editUserSign(pd);
		}
	}

	/** 设置用户的签字信息
	 * @param pd
	 * @throws Exception
	 */
	public void editUserSignType(PageData pd)throws Exception{
		userinfoMapper.editUserSignType(pd);
	}

}

